# NEVER EDIT this file.  It was generated and will be overwritten without
# notice upon regeneration of this application.  You have been warned.
package Billing::GEN::Customer;

use strict;
use warnings;

use base 'Billing';
use JSON;
use Gantry::Utils::TablePerms;

use Billing::Model::customer qw(
    $CUSTOMER
);

#-----------------------------------------------------------------
# $self->do_main(  )
#-----------------------------------------------------------------
sub do_main {
    my ( $self ) = @_;

    $self->stash->view->template( 'results.tt' );
    $self->stash->view->title( 'Customers' );

    my $real_location = $self->location() || '';
    if ( $real_location ) {
        $real_location =~ s{/+$}{};
        $real_location .= '/';
    }

    my @header_options = (
        {
            text => 'Add',
            link => $real_location . "add",
            type => 'create',
        },
    );

    my $retval = {
        headings       => [
            'Name',
            'Contact Name',
            'Contact Phone',
        ],
    };

    my %param = $self->get_param_hash;

    my $search = {};
    if ( $param{ search } ) {
        my $form = $self->form();

        my @searches;
        foreach my $field ( @{ $form->{ fields } } ) {
            if ( $field->{ searchable } ) {
                push( @searches,
                    ( $field->{ name } => { 'like', "%$param{ search }%"  } )
                );
            }
        }

        $search = {
            -or => \@searches
        } if scalar( @searches ) > 0;
    }

    my @row_options = (
        {
            text => 'Edit',
            type => 'update',
        },
        {
            text => 'Delete',
            type => 'delete',
        },
    );

    my $perm_obj = Gantry::Utils::TablePerms->new(
        {
            site           => $self,
            real_location  => $real_location,
            header_options => \@header_options,
            row_options    => \@row_options,
        }
    );

    $retval->{ header_options } = $perm_obj->real_header_options;

    my $limit_to_user_id = $perm_obj->limit_to_user_id;
    $search->{ user_id } = $limit_to_user_id if ( $limit_to_user_id );

    my $schema = $self->get_schema();
    my @rows   = $CUSTOMER->get_listing(
        {
            schema   => $schema,
            where    => $search,
        }
    );

    ROW:
    foreach my $row ( @rows ) {
        last ROW if $perm_obj->hide_all_data;

        my $id = $row->id;

        push(
            @{ $retval->{rows} }, {
                orm_row => $row,
                data => [
                    $row->name,
                    $row->contact_name,
                    $row->contact_phone,
                ],
                options => $perm_obj->real_row_options( $row ),
            }
        );
    }

    if ( $param{ json } ) {
        $self->template_disable( 1 );

        my $obj = {
            headings        => $retval->{ headings },
            header_options  => $retval->{ header_options },
            rows            => $retval->{ rows },
        };

        my $json = objToJson( $obj, { skipinvalid => 1 } );
        return( $json );
    }

    $self->stash->view->data( $retval );
} # END do_main

#-----------------------------------------------------------------
# $self->form( $row )
#-----------------------------------------------------------------
sub form {
    my ( $self, $row ) = @_;

    my $selections = $CUSTOMER->get_form_selections(
            { schema => $self->get_schema() }
    );

    return {
        name       => 'customer',
        row        => $row,
        legend => $self->path_info =~ /edit/i ? 'Edit' : 'Add',
        fields     => [
            {
                name => 'name',
                label => 'Name',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'address',
                label => 'Address',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'city',
                label => 'City',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'state',
                label => 'State',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'zip',
                label => 'Zip',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'description',
                optional => 1,
                label => 'Description',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'contact_name',
                optional => 1,
                label => 'Contact Name',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'contact_email',
                optional => 1,
                label => 'Contact Email',
                type => 'text',
                is => 'varchar',
            },
            {
                name => 'contact_phone',
                optional => 1,
                label => 'Contact Phone',
                type => 'text',
                is => 'varchar',
            },
        ],
    };
} # END form

1;

=head1 NAME

Billing::GEN::Customer - generated support module for Billing::Customer

=head1 SYNOPSIS

In Billing::Customer:

    use base 'Billing::GEN::Customer';

=head1 DESCRIPTION

This module was generated by bigtop and IS subject to regeneration.
Use it in Billing::Customer to provide the methods below.
Feel free to override them.

=head1 METHODS

=over 4

=item do_main

=item form


=back

=head1 AUTHOR

Generated by bigtop and subject to regeneration.

=cut

